[双指针] 1. 力扣283.移动零

题目链接:

https://leetcode.cn/problems/move-zeroes/

一. 题目描述

给定一个数组 nums,编写一个函数将所有 0 移动到数组的末尾,同时保持非零元素的相对顺序(保持相对顺序不是排序哦)。
请注意 ,必须在不复制数组的情况下原地对数组进行操作。

示例 1:
输入:
nums = 0,1,0,3,12
输出: 1,3,12,0,0

示例 2:
输入:
nums = 0
输出: 0

提示:

  • 1 <= nums.length <= 104
  • -231 <= nums[i] <= 231 - 1

二. 解题思路

1)这属于一个数组划分,数组分块的问题。针对这类题经典的解法就是双指针算法。这里的双指针不是真的指针,而是用下标充当"指针"。

2)指针

  1. dest(destination,目的地):指向已经处理的区间内,最后一个非零元素的位置。

  2. cur(current,当前的):从左向右扫描遍历数组,指向当前遍历到的位置。

3)通过两个指针将数组划分成三部分,也就是三个区间。

4)初始状态

  1. dest:最开始还没有处理过的区间,自然也就没有dest,所以dest开始指向-1的位置。

  2. cur:从头开始遍历数组,所以cur开始指向0的位置。

5)情况处理

cur在遍历时只可能遇到两种情况:0 或 非0

  1. 遇到0:说明这个0在已处理区间的右边,符合预期不用处理,直接 cur++ 。

  2. 遇到非0:dest指向的是已经处理过的区间里最后一个非零元素的位置,也就意味着他的右边一个一定是0,所以我们先将 dest++ 来到0的位置,然后将cur位置的非零元素与其交换,即swap(numsdest, numscur); 然后再将 cur++ ,继续往下遍历。

6)循环结束条件
cur遍历完数组越界时,循环结束,数组内所有数字都处理过了。

三. 代码实现

cpp 复制代码
class Solution 
{
public:
    void moveZeroes(vector<int>& nums) 
    {
        int dest = -1, cur = 0;
        int n = nums.size();
        while(cur < n)
        {
            if(nums[cur] == 0)   cur++;
            else 
            {
                dest++;
                swap(nums[dest], nums[cur]);
                cur++;
            }
        }
    }
};
相关推荐
tangguofeng41 分钟前
基于分治策略的循环赛日程表问题的思路讲解
算法
起个名字费劲死了1 小时前
VisionMaster集成深度学习算法(基础狗)
人工智能·深度学习·算法
lengxuenong1 小时前
枚举例题分析
c++·算法·青少年编程
Navigator_Z1 小时前
LeetCode //C - 1269. Number of Ways to Stay in the Same Place After Some Steps
c语言·算法·leetcode
2601_965742221 小时前
短视频脚本创作方法分享:本地生活类账号的起步思路
大数据·人工智能·算法·ai·新媒体运营·生活
55873生态系统手记2 小时前
读完 55873 资产钱包的技术栈,我重新理解了 "合规钱包" 应该长什么样
算法·架构
旋生万物2 小时前
素数螺旋映射 $z_n=n^{1+i}$ 的角分布统计检验与零模型对比
大数据·前端·人工智能·算法·云原生·螺旋生成论·螺旋相位
HRTOS2 小时前
HRTOS Shell继续完善:优化printf缓冲区与字符串越界保护,国庆后随新版本更新
运维·单片机·嵌入式硬件·算法·51单片机
邵奈一2 小时前
当沉香之乡遇上 Seed-2.1-pro:我用 AI 给村子做了一个数字门面
算法·架构
海天一色y2 小时前
图像分割全解析:从经典算法到深度学习的原理与实战(Python + MATLAB)
python·深度学习·算法